Bug 1541346 - Review Request: phpunit7 - The PHP Unit Testing framework
Review Request: phpunit7 - The PHP Unit Testing framework
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Robert-André Mauchin
Fedora Extras Quality Assurance
:
Depends On: 1539554 1541334 1541337 1541340 1541343
Blocks: 1542485 1543060
  Show dependency treegraph
 
Reported: 2018-02-02 05:35 EST by Remi Collet
Modified: 2018-02-07 11:23 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2018-02-07 10:01:14 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
zebob.m: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Remi Collet 2018-02-02 05:35:24 EST
Spec URL: https://git.remirepo.net/cgit/rpms/phpunit/phpunit7.git/plain/phpunit7.spec?id=266ad48fa5bc5ddae6f3b6d44594d41d92f771da
SRPM URL: http://rpms.remirepo.net/SRPMS/phpunit7-7.0.0-1.remi.src.rpm
Description:
PHPUnit is a programmer-oriented testing framework for PHP.
It is an instance of the xUnit architecture for unit testing frameworks.


Fedora Account System Username: remi
Comment 1 Robert-André Mauchin 2018-02-05 11:18:39 EST
 - Group: and %{!?_licensedir:%global license %%doc} are not needed

 - RPMLint error:

phpunit7.noarch: E: wrong-script-interpreter /usr/bin/phpunit7 /usr/bin/env php

   Policy is not to use env in Fedora. What is the motivation for removing 
brp_mangle_shebangs ?


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (2 clause)", "Unknown or generated", "*No copyright* BSD
     (3 clause)". 600 files have unknown license. Detailed output of
     licensecheck in /home/bob/packaging/review/phpunit7/review-
     phpunit7/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 3 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: phpunit7-7.0.0-1.fc28.noarch.rpm
          phpunit7-7.0.0-1.fc28.src.rpm
phpunit7.noarch: W: spelling-error %description -l en_US xUnit -> x Unit, unit
phpunit7.noarch: E: wrong-script-interpreter /usr/bin/phpunit7 /usr/bin/env php
phpunit7.noarch: W: no-manual-page-for-binary phpunit7
phpunit7.src: W: spelling-error %description -l en_US xUnit -> x Unit, unit
2 packages and 0 specfiles checked; 1 errors, 3 warnings.
Comment 2 Remi Collet 2018-02-06 00:22:44 EST
(In reply to Robert-André Mauchin from comment #1)
>  - RPMLint error:
> 
> phpunit7.noarch: E: wrong-script-interpreter /usr/bin/phpunit7 /usr/bin/env
> php
> 
>    Policy is not to use env in Fedora. What is the motivation for removing 
> brp_mangle_shebangs ?

Because I don't agree with this Guidelines.

Such packages works perfectly with different PHP versions (for most PHP projects, compatibility with newer PHP version is considered as a standard feature, and when needed, fixed as a bug)

This is commonly used in travis, daily, by tons of project to ensure compatibility with various PHP versions.

Having this package locked with default version will make no sense, making it unusable, and this will encourage php users to use the upstream distribution (.phar file) instead of this package.

This is described in 
https://blog.remirepo.net/post/2016/04/16/My-PHP-Workstation (§ Working on PHP code)

This specific version doesn't support old PHP version, but handles this properly

  $ module load php56
  $ phpunit7 
  This version of PHPUnit is supported on PHP 7.1 and PHP 7.2.
  You are using PHP 5.6.33 (/opt/remi/php56/root/usr/bin/php).


When I submit this review this was still under discussion by FPC
as https://pagure.io/packaging-committee/issue/725 is now rejected, I'm sad

So I you prefer, I can remove the macro for the review
(well... to be honest... I will probably re-add it later)
Comment 4 Robert-André Mauchin 2018-02-06 09:44:38 EST
Package approved.

But as said in the ticket, you need to discuss this in the ML, and try to convert people to your pov. I remember Igor was quite opposed to this.
Comment 5 Remi Collet 2018-02-07 02:20:56 EST
Thanks for the review

SCM request
https://pagure.io/releng/fedora-scm-requests/issue/4441
Comment 6 Gwyn Ciesla 2018-02-07 09:26:34 EST
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/phpunit7

Note You need to log in before you can comment on or make changes to this bug.